----------------------------------------
-- USB
----------------------------------------

-------------------------------------------------------------------------------
-- Notes
---- 2006.10.26 
------ ƏĂ݂B
------ clock̎ԑz͂ǂ悤˂B100MHzƎvΖȂ̂H
---- 2006.10.27
------ f[^̓o̓^C~OBvZXOɂĂ݂B
------ ɏBValidMB
-------------------------------------------------------------------------------

library IEEE;
use IEEE.std_logic_1164.all;
use IEEE.std_logic_arith.all;
use IEEE.std_logic_unsigned.all;

entity USB is
  
  port (
    CLK      : in    std_logic;                      -- system closk
    RESET    : in    std_logic;                      -- reset signal 
    DATA_IN  : in    std_logic_vector(7 downto 0);   -- data to usb
    DATA_OUT : out   std_logic_vector(7 downto 0);   -- data from usb
    USBIN    : in    std_logic;                      -- usb read
    USBOUT   : in    std_logic;                      -- usb write
    BUSY     : out   std_logic;                      -- usb is busy = '1'
    VALID    : out   std_logic;                      -- data read valid
    -- to usb
    NRESET   : out   std_logic;                      -- usb reset 
    NRD      : out   std_logic;                      -- on read '0'
    WR       : out   std_logic;                      -- on write '1'
    NTXE     : in    std_logic;                      -- on full buffer '1'
    NRXF     : in    std_logic;                      -- on empty buffer '1'
    USB_DATA : inout std_logic_vector(7 downto 0));  -- usb data

end USB;

architecture usb_arc of USB is 
 -- state (count up)
  signal USB_STATE : std_logic_vector(3 downto 0);
  signal FLAG : std_logic;              -- Read = '0' Write = '1'
  
begin  -- usb_arc

  USB_DATA <= DATA_IN when WR = '1' else
              "ZZZZZZZ";
  DATA_OUT <= USB_DATA;
  NRESET <= '0';
  
  process (CLK,RESET)
  begin
    if RESET = '1' then      -- Reset
      BUSY <= '0';
      VALID <= '0';

      NRESET <= '1';
      NRD <= '1';
      WR <= '0';

      USB_STATE <= "0000";
      FLAG <= '1';
         
    elsif CLK'event and CLK = '1' then
      case USB_STATE is
        when "0000" =>
          if USBIN = '1' then
            -- write
            if NTXE = '0' then
              BUSY <= '1';
              VALID <= '0';
              WR <= '1';
              FLAG <= '1';
            end if;
            USB_STATE <= USB_STATE + 1;
          elsif USBOUT = '1' then
            -- read
            if NRXF = '0' then
              BUSY <= '1';
              VALID <= '0';
              NRD <= '0';
              FLAG <= '0';
            end if;
            USB_STATE <= USB_STATE + 1;
          else
            USB_STATE <= "0000";
          end if;
        when "0001" | "0010" | "0011" =>
          USB_STATE <= USB_STATE + 1;
        when "0100" =>
          if FLAG = '1' then -- write O.K.
           VALID <= '1';
          end if;
          USB_STATE <= USB_STATE + 1;
        when "0101" =>
          if FLAG = '1' then
            VALID <= '0';
          end if;
          USB_STATE <= USB_STATE + 1;
        when "0110" =>
          if FLAG = '1' then
            NRD <= '1';
          else
            WR <= '0';
          end if;
          USB_STATE <= USB_STATE + 1;
        when "0111" | "1000" | "1001" | "1010" | "1011" | "1100" | "1101"  =>
          USB_STATE <= USB_STATE + 1;
        when "1111" =>
          USB_STATE <= "0000";
          BUSY <= '0';
          FLAG <= '1';
        when others =>
          USB_STATE <= "0000";
          BUSY <= '0';
      end case; 
    end if;
  end process;
end usb_arc;
